//#line 2 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the pcl_ros package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __pcl_ros__FILTERCONFIG_H__
#define __pcl_ros__FILTERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace pcl_ros
{
  class FilterConfigStatics;
  
  class FilterConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const FilterConfig &config1, const FilterConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, FilterConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const FilterConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, FilterConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const FilterConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T FilterConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (FilterConfig::* field);

      virtual void clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const FilterConfig &config1, const FilterConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, FilterConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const FilterConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, FilterConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const FilterConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 12 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      std::string filter_field_name;
//#line 13 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      double filter_limit_min;
//#line 14 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      double filter_limit_max;
//#line 15 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      bool filter_limit_negative;
//#line 16 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      std::string input_frame;
//#line 17 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      std::string output_frame;
//#line 138 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("FilterConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const FilterConfig &__max__ = __getMax__();
      const FilterConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const FilterConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const FilterConfig &__getDefault__();
    static const FilterConfig &__getMax__();
    static const FilterConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const FilterConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void FilterConfig::ParamDescription<std::string>::clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const
  {
    return;
  }

  class FilterConfigStatics
  {
    friend class FilterConfig;
    
    FilterConfigStatics()
    {
//#line 12 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.filter_field_name = "";
//#line 12 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.filter_field_name = "";
//#line 12 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.filter_field_name = "z";
//#line 12 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<std::string>("filter_field_name", "str", 0, "The field name used for filtering", "", &FilterConfig::filter_field_name)));
//#line 13 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.filter_limit_min = -5.0;
//#line 13 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.filter_limit_min = 5.0;
//#line 13 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.filter_limit_min = 0.0;
//#line 13 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("filter_limit_min", "double", 0, "The minimum allowed field value a point will be considered from", "", &FilterConfig::filter_limit_min)));
//#line 14 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.filter_limit_max = -5.0;
//#line 14 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.filter_limit_max = 5.0;
//#line 14 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.filter_limit_max = 1.0;
//#line 14 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("filter_limit_max", "double", 0, "The maximum allowed field value a point will be considered from", "", &FilterConfig::filter_limit_max)));
//#line 15 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.filter_limit_negative = 0;
//#line 15 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.filter_limit_negative = 1;
//#line 15 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.filter_limit_negative = 0;
//#line 15 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<bool>("filter_limit_negative", "bool", 0, "Set to true if we want to return the data outside [filter_limit_min; filter_limit_max].", "", &FilterConfig::filter_limit_negative)));
//#line 16 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.input_frame = "";
//#line 16 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.input_frame = "";
//#line 16 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.input_frame = "";
//#line 16 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<std::string>("input_frame", "str", 0, "The input TF frame the data should be transformed into before processing, if input.header.frame_id is different.", "", &FilterConfig::input_frame)));
//#line 17 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __min__.output_frame = "";
//#line 17 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __max__.output_frame = "";
//#line 17 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __default__.output_frame = "";
//#line 17 "/tmp/buildd/ros-diamondback-perception-pcl-0.10.0/debian/ros-diamondback-perception-pcl/opt/ros/diamondback/stacks/perception_pcl/pcl_ros/cfg/Filter_common.py"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<std::string>("output_frame", "str", 0, "The output TF frame the data should be transformed into after processing, if input.header.frame_id is different.", "", &FilterConfig::output_frame)));
//#line 239 "/opt/ros/diamondback/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<FilterConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<FilterConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    FilterConfig __max__;
    FilterConfig __min__;
    FilterConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const FilterConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static FilterConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &FilterConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const FilterConfig &FilterConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const FilterConfig &FilterConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const FilterConfig &FilterConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<FilterConfig::AbstractParamDescriptionConstPtr> &FilterConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const FilterConfigStatics *FilterConfig::__get_statics__()
  {
    const static FilterConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = FilterConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __FILTERRECONFIGURATOR_H__
